/********************************************************************
@t@C
	lcdtest.c

  
	Interface LPC2388pTv@gcc_sample
	(^C}荞LED_vO)
	x[XɁAKenic system UNT3224-L30P eXgɉC

	by Kou, IT-ACCESS
	2009/11/25

   F
	NɃTv`A^b`plƍWƕ`s
	ԂŉʃtbVs

********************************************************************/

#include	"LPC2300.h"
#include 	"lcdlib.h"	

// define 16bitRGB[h̃eXgiQl̂݁j
//#define	_TEST_RGB16

// `eXgR[h
void draw_test16( unsigned short col ) ;
void draw_test( void );

// LED_ł̊荞݂Ƃ肠^C}[
#define	CLEAR_TIMER		100
static unsigned char TimerCnt ;

// ^b`plW
static unsigned short Tx, Ty ;

// _`Ƃ̃J[
static unsigned int ColNum ;

/*static*/ unsigned char ColTbl[8] = {
	ORANGE,YELLOW,
	LIGHT_BLUE,	LIGHT_RED, LIGHT_GREEN,
	BLUE,GREEN,RED, 
} ;


/****************************************************************************
	^C}荞݃TvvO(I{[hLED_)
	...EMCpǉC shimizu 2009/9/xx
****************************************************************************/


/* LED_ŗpϐ */
int LED_Blink;

/* CPU荞݋ */
void CPU_EnableInterrupt()
{
  volatile unsigned int CPSR_val;
  asm ("MRS %0, CPSR": "=r" (CPSR_val):);
  CPSR_val &= ~0x80;
  asm ("MSR CPSR, %0": :"r" (CPSR_val));
}

/* CPU荞݋֎~ */
void CPU_DisableInterrupt()
{
  volatile unsigned int CPSR_val;
  asm ("MRS %0, CPSR": "=r" (CPSR_val):);
  CPSR_val |= 0x80;
  asm ("MSR CPSR, %0": :"r" (CPSR_val));
}

/* CPU荞ݏ */

void draw_test(void) ;

void CPU_IRQInterrupt(void)
{
	if( LED_Blink == 0 ) {
		LED_Blink = 1;
		FIO1PIN  =0x00000000;	/* P1[18] '0' -> LED ON */
	} else {
		LED_Blink = 0;
		FIO1PIN =0x00040000;	/* P1[18] '1' -> LED OFF */
	}
	T0IR =1;		/* ^C}荞݃NA */
	TimerCnt++ ;
}



/********************************************************************
	֐
		fnLCDInit
	
		Ȃ
	߂l
		Ȃ
	
		LCDRg[֘A
********************************************************************/
void fnLCDInit(void)
{
	/*LCDRg[*/
#ifdef	_TEST_RGB16
	fnSetReg1( 0x84 );	/* 16bitRGB, Penetrate enable , Blink1 enable Blink2 enable */
#else
	fnSetReg1( 0x70 );	/* Colorpalette(64color) Penetrate enable , Blink1 enable Blink2 enable */
#endif
	fnSetReg2( 0x00 );
	fnSetReg3( 0x05 );
//	fnSetReg4( 0x7f );	/* MAX LED backlight duty */
	fnSetReg4( 0x64 );

#ifndef	_TEST_RGB16
	set_default_colormap(); 
#endif
}


/*********************************************************************
	֐
		init_HW
	
		Ȃ
	߂l
		Ȃ
	
		LPC2388 CPU֘A
*********************************************************************/
static void LPC2388_PLLInit(void)
{
#define PLL_N		2UL
#define PLL_M		72UL
#define CCLK_DIV	4

	if ( PLLSTAT & (1 << 25) ) {
		PLLCON = 1;				/* Disconnect PLL output if PLL is in use */
		PLLFEED = 0xAA;
		PLLFEED = 0x55;
	}
	PLLCON = 0;				/* Disable PLL */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;
	CLKSRCSEL = 0;			/* Select IRC (4MHz) as the PLL clock input */

	PLLCFG = ((PLL_N - 1) << 16) | (PLL_M - 1);	/* Re-configure PLL */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;
	PLLCON = 1;				/* Enable PLL */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;

	while ((PLLSTAT & (1 << 26)) == 0);	/* Wait for PLL locked */

	CCLKCFG = CCLK_DIV-1;	/* Select CCLK frequency (divide ratio of hclk) */
	PLLCON = 3;				/* Connect PLL output to the sysclk */
	PLLFEED = 0xAA;
	PLLFEED = 0x55;

	MAMCR = 0;				/* Configure MAM for 72MHz operation */
	MAMTIM = 3;
	MAMCR = 2;
}

void init_HW( void )
{
	LPC2388_PLLInit();
	SCS = SCS | 1;	/* FGPIO Select */

	/* LED_ݒ */
	FIO1DIR = 0x00040000;	/* P1[18] OutPut */
	FIO1MASK = 0x00000000;	/* P1[18] Non Mask */
	FIO1PIN = 0x00040000;	/* P1[18] '1' -> LED OFF */

	/* ^C}Rg[ւ̋NbNݒ */
	PCLKSEL0 = (PCLKSEL0 & 0xfffffff3); /* 1/4 */

	/* ^C}0̃p[^ݒ */
	LED_Blink = 0;
	T0PR  = 0x00000000;		/* vXP[ */
	T0MR0 = 1000000;			/* NbNg=1b */
	T0MCR = 0x00000003;		/* MatchTCNA&荞 */
	T0TCR = 1;	/* ^C}X^[g*/

	/* SRAMRg[ݒ */
	PCONP = 0x06280FFE;			/* lށ@*/
/*	EMC_STAT = 0x6; */			/* */
	PINSEL6 = 0x00005555;		/* Pin Serect Data Set */
	PINSEL8 = 0x55555555;		/* Pin Serect Address Set */
	PINSEL9 = 0x50090000;		/* Pin Serect CS1/0 & BLS & CE Set */

	EMC_CTRL = 0x0001 ;	// default =3 , bit1 Mirror -> Normal memory map
}

/*********************************************************************

  Main֐ startup.S

*********************************************************************/

int main(void)
{
	init_HW() ;

	fnLCDInit();	/* LCD 351		*/

	TimerCnt = 0 ;
	ColNum = 0 ;
	Tx = Ty = 0 ;

#ifdef	_TEST_RGB16
	draw_test16( 0xff00 ) ;
#else
	cls(BLACK);		/*ʂ̏@Fœh܂B*/
	fnChkClsend();		/*ʃNAbit̏Iҋ@Ă܂B*/

	draw_test();

#endif

	/* 荞݃Rg[ݒ */
	VICIntSelect = VICIntSelect & (~0x10);	/* IRQI */
	VICIntEnable = VICIntEnable |   0x10;	/* ^C}0̂ݗL */

	/* 荞݋ */
	CPU_EnableInterrupt();

	draw_test();	// ?? 1ڕ`ɖAH

	for(;;){
		if(TimerCnt >= CLEAR_TIMER) {
			cls(BLACK);		/*ʃNA@*/
			fnChkClsend();		/*ʃNAbit̏Iҋ@Ă܂B*/
			ColNum = (ColNum+1) & 0x07 ;
			TimerCnt = 0 ;
		}
		if ( touch_read( &Tx, &Ty ))  {
			fn7seg( 160,200,Tx,3, LIGHT_RED,DARK_RED);	/*Ww肵ĂR̂VZO\܂B*/
			fn7seg( 220,200,Ty,3, LIGHT_RED,DARK_RED);	/*Ww肵ĂR̂VZO\܂B*/
			fnCircleC( Tx, Ty, 4, 4, ColTbl[ColNum]) ;
		}

	}	/* [v */

}

/*********************************************************************
@`eXgTvR[h
*********************************************************************/
void draw_test( void )
{
	/*@Lcdlib.c֐*/
	int x,y,i ;
	i=0;
	for ( y = 10; y < 100; y+=12 ) {
	for ( x = 10; x < 300; x+=12 ) {
		fnCircleC( x, y,6,6, ((i++)&0x3f) );		/*SƔaw肵āA~܂BiFw肪KvłBj*/
	}}
	fnDot(20,220,WHITE);			/*Fw肵ē_ł*/

	fnLine( 50,120,280,200,BLUE );		/*Q_Ԃ̍Ww肵āA܂BiFw肪KvłBj*/

	fnCircle( 220,140,30,30,RED );		/*SƔaw肵āA~܂BiFw肪KvłBj*/

	fnPaintBox( 200,120,240,40,GREEN );	/*Q_Ԃw肵āAanwh܂BiFw肪KvłBj*/

	fn7seg( 60,160,123,3, YELLOW,DARK_GREEN);	/*Ww肵ĂR̂VZO\܂B*/

}

#ifdef	_TEST_RGB16
static unsigned short coltbl[16]={
	0x0000, 0x001f, 0x03e0, 0xf800, 
	0x0000, 0x001f, 0x03e0, 0xf800, 
	0x0000, 0x001f, 0x03e0, 0xf800, 
	0x0000, 0x001f, 0x03e0, 0xf800 } ;

void draw_test16( unsigned short col )
{
	unsigned short x,y, n ;

	n = ((TimerCnt&0x0f)*10) ;
	if(col) col = coltbl[TimerCnt&0x0f] ;

	for (y=50 ;y<60; y++) {
	for (x=100;x<110; x++) {
		fnDot16( x+n, y+n, col ) ;
	}}
}
#endif
